# GraphQL Compose

> Toolkit for generating GraphQL schemas in Drupal.

The main goal of this project is to provide a GraphQL spec compliant schema generation for the GraphQL module v4.x

There are plans to provide a GUI (YAML/JSON file will be supported for the initial release) to allow users to define how they want to name things and what to expose.

There are no plans to provide CLI commands, since that will probably limit the number of users that can take advantage of this module to only users that feel confortable using the CLI.

Other possible features from current v3.x modules that could considered to be added:
- GraphQL Mutation
- GraphQL Responsive Image
- GraphQL Metatag
- GraphQL Extras
- GraphQL Formatters
- GraphQL Config
- GraphQL Entity Definitions
- GraphQL Redirect / Redirect Entity
- GraphQL OAuth
- Graphql JWT
- GraphQL WebP
- GraphQL Views

## TODO

- [ ] Make Media discovery and registration automatic
  - [x] Add support for Media Images
  - [ ] Add support for File Images
- [x] Make User fields discovery and registration automatic
- [ ] Add support for Media Unions
  - [x] Image
  - [ ] Audio
  - [ ] Document
  - [ ] Video
  - [ ] Remote Video
- [ ] Add support for Field Unions
  - [x] entity_reference
  - [x] entity_reference_revisions
  - [ ] other
- [ ] Add support for Core Fields
  - [ ] Image
  - [ ] Link
  - [ ] String
  - [ ] String Long
- [x] Add support for Extend Fields
- [x] Add support for Paragraph Unions

## Contribute with this module

 If interested to contribute or fund to the development of this module contact us via email [opensource@octahedroid.com](mailto:opensource@octahedroid.com).

## Credits

This code is based on the excellent Open Social GraphQL module.

